From 82294ccbd582df3166a94a71aee503fdb5bc003a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 21:41:55 +0000
Subject: [PATCH 1280/2232] Detect non-absolute exported header dirs


---

diff --git a/gen/build/src/error.rs b/gen/build/src/error.rs
index 2fbd41d..069723b 100644
--- a/gen/build/src/error.rs
+++ b/gen/build/src/error.rs
@@ -2,6 +2,7 @@ use crate::gen::fs;
 use std::error::Error as StdError;
 use std::ffi::OsString;
 use std::fmt::{self, Display};
+use std::path::Path;
 
 pub(super) type Result<T, E = Error> = std::result::Result<T, E>;
 
@@ -9,6 +10,7 @@ pub(super) type Result<T, E = Error> = std::result::Result<T, E>;
 pub(super) enum Error {
     NoEnv(OsString),
     Fs(fs::Error),
+    ExportedDirNotAbsolute(&'static Path),
 }
 
 impl Display for Error {
@@ -18,6 +20,11 @@ impl Display for Error {
                 write!(f, "missing {} environment variable", var.to_string_lossy())
             }
             Error::Fs(err) => err.fmt(f),
+            Error::ExportedDirNotAbsolute(path) => write!(
+                f,
+                "element of CFG.exported_header_dirs must be absolute path, but was: {:?}",
+                path,
+            ),
         }
     }
 }
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 60797a5..d5588b1 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -193,6 +193,9 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
     this_crate.exported_header_dirs.push(include_dir);
     this_crate.exported_header_dirs.extend(crate_dir);
     for exported_dir in &CFG.exported_header_dirs {
+        if !exported_dir.is_absolute() {
+            return Err(Error::ExportedDirNotAbsolute(exported_dir));
+        }
         this_crate
             .exported_header_dirs
             .push(PathBuf::from(exported_dir));

